Index: trunk/SophyaLib/NTools/cimage.h
===================================================================
--- trunk/SophyaLib/NTools/cimage.h	(revision 1103)
+++ trunk/SophyaLib/NTools/cimage.h	(revision 1104)
@@ -1,6 +1,5 @@
 // This may look like C code, but it is really -*- C++ -*-
-//  Classes image typee      E.Aubourg , E. Lesquoy     
-//                           Modifs R. Ansari   04/95
-
+//  Classes image heritant de TMatrix<T>
+//                       R.Ansari, C.Magneville 07/2000    
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
@@ -8,12 +7,5 @@
 #define CIMAGE_SEEN
 
-#include <iostream.h>
-#include <iomanip.h>
-#include "rzimage.h"
-
-// Flags de verifications sur les indices  dans rzimage.h 
-
-//#define IMGRGCHECK
-//#define IMGVOIDCHECK
+#include "tmatrix.h"
 
 
@@ -21,278 +13,79 @@
 // Classe Image
 
+namespace SOPHYA {
 
 template <class T>
-class Image : public RzImage {
+class Image : public TMatrix<T> {
 
 public:
-  Image(int sizx, int sizy, int zero=1);
   Image();
-  Image(const Image<T>&, int sharePixels=0);
-  Image(const Image<T>&, int orgx, int orgy, int sizx=-1, int sizy=-1);
-  EXPLICIT Image(const RzImage&); // Pour Reza. Partage les pixels
-  Image(char *flnm);
+  Image(uint_4 sizx, uint_4 sizy, r_8 szpx=1., r_8 szpy=1., r_8 orgx=0., r_8 orgy=0.);
+  Image(const Image<T>& a);
+  Image(const Image<T>& a, bool share);
+
   virtual ~Image();
 
-  static PPersist*      Create()              { return new Image<T>;}
+  // Inline element acces methods 
+  inline T const& operator()(uint_4 ix,uint_4 jy) const;
+  inline T&       operator()(uint_4 ix,uint_4 jy);
 
-  virtual void    ReadSelf(PInPersist&);
+  inline uint_4  XSize() const {return NCols();}
+  inline uint_4  YSize() const {return NRows();}
 
-  Image<T>&       operator= (const Image<T> &);
-  Image<T>&       operator= (T);
+  inline r_8     XOrg() const {return org_x;}
+  inline r_8     YOrg() const {return org_y;}
 
-  Image<T>&       operator+= (Image<T> const&);
-  Image<T>&       operator-= (Image<T> const&);
-  Image<T>&       operator*= (Image<T> const&);
-  Image<T>&       operator/= (Image<T> const&);
+  inline r_8     XPixSize() const {return pxsz_x;}
+  inline r_8     YPixSize() const {return pxsz_y;}
 
-  Image<T>&       operator+= (double);
-  Image<T>&       operator-= (double);
-  Image<T>&       operator*= (double);
-  Image<T>&       operator/= (double);
-
-  Image<T>        WhereNonZero();
-
-
-//   Impression de tout le contenu de l'image 
-  virtual void    PrintImage(ostream& os) const;
-  inline void     PrintImage() const  { PrintImage(cout); }
-
-  void            Zero();
-  void            Allocate(int sizx, int sizy, int zero=1, ImgVectP* pvpsh=NULL);
-
-  inline T&       operator() (int x, int y);
-  inline T        operator() (int x, int y) const;
-  inline T&       operator[] (int i);
-  inline T        operator[] (int i) const;
-  T*              ImagePtr()         {return imagePtr;}
-  const T*        ImagePtr() const   {return imagePtr;}
-                                            
-  int             CheckDyn(double min=-9.e19, double max=9.e19);
-
-  void            SeuilBas(double seuil, double val);
-  void            SeuilHaut(double seuil, double val);
-  void            SeuilBas(double seuil);
-  void            SeuilHaut(double seuil);
-  void            SetPixels(int szx, int szy, T* pim);
-
-  int EstimeFdSg(float& xbmax,float& sgbmax,float nbsig=3.5,float frac=0.33
-                ,float lowbad=1.,float highbad=-1.,int deb=0);
-  float FondCiel(int nbin,float bin_low,float bin_high
-                ,int degre=2,float frac=0.5f,int modu=1,int deb=0);
-  float SigmaCiel(int nbin,float bin_low,float bin_high,float& means
-                 ,float lowbad=1.,float highbad=-1.
-                 ,float nsig=4.f,int modu=1,int deb=0);
-  int   MoySigma(float& mean,float& sigma
-                ,float lowbad=1.,float highbad=-1.,int modu=1);
-  int   MoySigmaIter(float& mean,float& sigma,float lowbad=1.,float highbad=-1.
-                    ,int modu=1,int nitermx=10
-                    ,float perdiff=0.1f,float scut=3.5f, int deb=0);
-  int   FondSigmaCiel(float lowbad,float highbad,int pvsz=100
-              ,float nbsig1=3.5f,float nbsig2=7.f,float nbsig3=5.f
-              ,float binsg=0.5f,float frac=0.33f,int modu=1,int deb=0);
-
+  inline void    SetOrg(r_8 orgx=0., r_8 orgy=0.)
+                       { org_x = orgx;  org_y = orgy; }  
+  inline void    SetPixelSize(r_8 szx=1., r_8 szy=1.)
+                       { pxsz_x = szx;   pxsz_y = szy; }
 
 protected:
-
-  void HBinInt(int& nbin,float& xmin,float& xmax);
-
-  T*              imagePtr;
+  r_8   org_x,org_y;        //  Coordonnees pixel(0,0)
+  r_8   pxsz_x, pxsz_y;     //  Taille des pixels
 };
 
-// Definition de l'operateur << 
-//template <class T> 
-//ostream& operator << (ostream& s, Image<T> const& img)
-//  {  img.Print(s);  return(s);  }
-
-
-/*  .......................................................  */
-/*          Implementation inline des acces pixels           */
-/*  .......................................................  */
-
-// ----- Macro de verification des indices  ------ 
-
-#ifdef IMGRGCHECK
-#define CHECKIMG(_x_,_y_)                                  \
-      if ((_x_ >= siz_x) || (_y_ >= siz_y) ||              \
-          (_x_ < 0) || (_y_ < 0)) THROW(rangeCheckErr);  \
-      if (!imagePtr) THROW(nullPtrErr)
-#else
-#if defined(IMGVOIDCHECK)
-#define CHECKIMG(_x_,_y_) \
-      if (!imagePtr) THROW(NullPtrErr)
-#else
-#define CHECKIMG(_x_,_y_)
-#endif
-#endif /* IMGRGCHECK */
-
-#define INRANGE(_x_,_y_) ((_x_ < siz_x) && (_y_ < siz_y) && \
-                          (_x_ >= 0) && (_y_ >= 0))
-
-
-// Fin des macros  ------ 
-
-
 template <class T>
-inline T & Image<T>::operator() (int x, int y)
+inline T const& Image<T>::operator()(uint_4 ix, uint_4 jy) const
 {
-  CHECKIMG(x,y);
-  return imagePtr[x+y*siz_x];
+  return (TMatrix<T>::operator() (jy, ix));
 }
 
 template <class T>
-inline T Image<T>::operator() (int x, int y) const
+inline T & Image<T>::operator()(uint_4 ix, uint_4 jy) 
 {
-  CHECKIMG(x,y);
-  return imagePtr[x+y*siz_x];
-}
-
-template <class T>
-inline T & Image<T>::operator[] (int i)
-{
-  CHECKIMG(0,0);
-  return imagePtr[i];
-}
-
-template <class T>
-inline T Image<T>::operator[] (int i) const
-{
-  CHECKIMG(0,0);
-  return imagePtr[i];
-}
-
-// Operateurs addition, multiplication, ... (+ - * / ) avec des doubles 
-
-template <class T> 
-Image<T> operator+ (Image<T> const& a, double b) 
-{
-  Image<T> c(a);
-  c += b;
-  return c;
-}
-
-template <class T> 
-Image<T> operator- (Image<T> const& a, double b) 
-{
-  Image<T> c(a);
-  c -= b;
-  return c;
-}
-
-template <class T> 
-Image<T> operator* (Image<T> const& a, double b) 
-{
-  Image<T> c(a);
-  c *= b;
-  return c;
-}
-
-template <class T> 
-Image<T> operator/ (Image<T> const& a, double b) 
-{
-  Image<T> c(a);
-  c /= b;
-  return c;
-}
-
-// Operateurs addition, multiplication, ... (+ - * / ) entre images
-template <class T> 
-Image<T> operator+ (Image<T> const& a, Image<T> const& b)
-{
-  Image<T> c(a);
-  c += b;
-  return c;
-}
-
-template <class T> 
-Image<T> operator- (Image<T> const& a, Image<T> const& b) 
-{
-  Image<T> c(a);
-  c -= b;
-  return c;
-}
-
-template <class T> 
-Image<T> operator* (Image<T> const& a, Image<T> const& b) 
-{
-  Image<T> c(a);
-  c *= b;
-  return c;
-}
-
-template <class T> 
-Image<T> operator/ (Image<T> const& a, Image<T> const& b) 
-{
-  Image<T> c(a);
-  c /= b;
-  return c;
+  return (TMatrix<T>::operator() (jy, ix));
 }
 
 
-/*  .......................................................  */
-/*         Fonctions de copie d'images et de paves           */
-/*  .......................................................  */
-
-template <class T2, class T1>
-void CopieImageF(Image<T2>& copie, Image<T1> const& pim,
-                 int org_pim_x=0, int org_pim_y=0,
-                 int pim_lpav_x=0, int pim_lpav_y=0,
-                 int org_copie_x=0, int org_copie_y=0,
-                 double cutmin=0., double cutmax=0.);
-                
-template <class T2, class T1>
-void CopieImage(Image<T2>& copie, Image<T1> const& pim);
-
-template <class T2, class T1>
-void CopieImage(Image<T2>& copie, Image<T1> const& pim,
-                int org_pim_x, int org_pim_y,
-                int pim_lpav_x=0, int pim_lpav_y=0,
-                int org_copie_x=0, int org_copie_y=0,
-                double cutmin=0, double cutmax=0);
-
-
-template <class T2, class T1>
-void 
-CopiePave(Image<T2>& pave, Image<T1> const& pim,
-	  float xc, float yc, 
-	  double cutmin=0, double cutmax=0);
-
-
-template <class T>
-void 
-RzCopieImage(Image<T>& copie, RzImage const& pim,
-	     int org_pim_x, int org_pim_y,
-	     int pim_lpav_x=0, int pim_lpav_y=0,
-	     int org_copie_x=0, int org_copie_y=0,
-	     double cutmin=0, double cutmax=0);
-
-template <class T>
-void 
-RzCopieImage(Image<T>& copie, RzImage const& pim);
-
-template <class T>
-void 
-RzCopiePave(Image<T> & pave, RzImage const & pim,
-	    float xc, float yc,
-	    double cutmin=0, double cutmax=0);
-/*  .......................................................  */
-/*         Autres fonctions utilitaires pour RzImage         */
-/*  .......................................................  */
-
-void RzPrintImage(RzImage & img);
-
-/*  Images de types usuels   */
-
-typedef Image<uint_1> ImageU1;
 typedef Image<uint_2> ImageU2;
-typedef Image<int_2>  ImageI2;
 typedef Image<int_4>  ImageI4;
 typedef Image<r_4>    ImageR4;
+typedef Image<r_8>    ImageR8;
 
+class GeneralFit;
+class RzImage {
+public:
+  RzImage() { }
+  ~RzImage() { }
+  inline uint_4  XSize() const {return 0;}
+  inline uint_4  YSize() const {return 0;}
 
-#ifdef __MWERKS__
-template <class T>
-ostream& operator << (ostream& s, Image<T> const& pim);
-#endif
+  inline r_8     XOrg() const {return 0;}
+  inline r_8     YOrg() const {return 0;}
 
+  inline r_8     XPixSize() const {return 1.;}
+  inline r_8     YPixSize() const {return 1.;}
+  inline r_8     DValue(int i, int j) const { return 0.; }
+  // Resultats d'un GeneralFit
+  inline RzImage*      FitResidus(GeneralFit& gfit) { return NULL; }
+  inline RzImage*      FitFunction(GeneralFit& gfit) { return NULL; }
+
+};
+
+}  // End of namespace SOPHYA
 
 #endif
Index: trunk/SophyaLib/NTools/dynccd.cc
===================================================================
--- trunk/SophyaLib/NTools/dynccd.cc	(revision 1103)
+++ trunk/SophyaLib/NTools/dynccd.cc	(revision 1104)
@@ -46,12 +46,12 @@
 //--
 //++
-// DynCCD(int TypNoise=0, float MinADU=-9.e19, float MaxADU=9.e19, float Gain=1., float RONoise=0., float RefFond=0., float RefSFond=0.);
+// DynCCD(int_4TypNoise=0, r_8 MinADU=-9.e19, r_8 MaxADU=9.e19, r_8 Gain=1., r_8 RONoise=0., r_8 RefFond=0., r_8 RefSFond=0.);
 //	Creation d'un objet DynCCD ("typ" determine la methode de calcul du bruit)
 //	|Test verbatim 
 //
-// void Set(int TypNoise=0, float MinADU=-9.e19, float MaxADU=9.e19, float Gain=1., float RONoise=0., float RefFond=0., float RefSFond=0.);
+// void Set(int_4TypNoise=0, r_8 MinADU=-9.e19, r_8 MaxADU=9.e19, r_8 Gain=1., r_8 RONoise=0., r_8 RefFond=0., r_8 RefSFond=0.);
 //	Modification des parametres de la dynamique
 // void Print()
-// float Noise(float pixel) const
+// r_8 Noise(r_8 pixel) const
 //	Renvoie la valeur du bruit pour "pixel" en ADU.
 //--
@@ -62,6 +62,6 @@
 
 /* --Methode-- */
-DynCCD::DynCCD(int typ, float min, float max, float g,
-               float ron, float rf, float rfs)
+DynCCD::DynCCD(int_4 typ, r_8 min, r_8 max, r_8 g,
+               r_8 ron, r_8 rf, r_8 rfs)
 {
 if ( (typ >= kConstantNoise) && (typ <= kSqrtADUNoise) )  TypNoise = typ;
@@ -73,6 +73,6 @@
 
 /* --Methode-- */
-void DynCCD::Set(int typ, float min, float max, float g,
-               float ron, float rf, float rfs)
+void DynCCD::Set(int_4 typ, r_8 min, r_8 max, r_8 g,
+               r_8 ron, r_8 rf, r_8 rfs)
 {
 if ( (typ >= kConstantNoise) && (typ <= kSqrtADUNoise) )  TypNoise = typ;
@@ -93,5 +93,5 @@
 
 /* --Methode-- */
-float DynCCD::Noise(float pixel) const
+r_8 DynCCD::Noise(r_8 pixel) const
 
 /* Cette fonction calcule la valeur du bruit pour pixel     */
@@ -108,6 +108,6 @@
 
 {
-float h,s,ronsq;
-float fond;
+r_8 h,s,ronsq;
+r_8 fond;
 
 if ( (pixel > MaxADU) || (pixel < MinADU) )   return(0.);
@@ -122,5 +122,5 @@
   ronsq = RONoise/Gain;  ronsq *= ronsq; }
 
-h = (pixel>fond) ? (float)(pixel-fond) : 0.;
+h = (pixel>fond) ? (r_8)(pixel-fond) : 0.;
 s = ronsq+h/Gain;
 s = fsqrt(s);
@@ -161,5 +161,5 @@
 /* Nouvelle-Fonction */
 template <class T>
-Image<T> * NoiseImage(Image<T> const * pim, DynCCD const * dynccd)
+Image<T>  NoiseImage(Image<T> const & pim, DynCCD const & dynccd)
 
 /* Creation et Calcul d'une image de bruit a partir de l'image */
@@ -168,85 +168,19 @@
 
 {
-float h,s,ronsq;
-float fond, min,max;
-int i, npix;
-float minois, offnois;
-
-if (pim == NULL)  return(NULL);
-
-const T * pix = pim->ImagePtr();
-npix = pim->XSize()*pim->YSize();
-Image<T> * nois = new Image<T>(pim->XSize(), pim->YSize(), false);
-nois->SetOrg(pim->XOrg(), pim->YOrg());
-T * pno = nois->ImagePtr();
-
-min = dynccd->MinADU;   max = dynccd->MaxADU;
-
-
-switch (dynccd->TypNoise)
-  {
-  case kConstantNoise :
-    for(i=0; i<npix; i++)
-      {
-      if ( (*pix <= max) && (*pix >= min) )  *pno = 1;
-      else *pno = 0;
-      pix++;   pno++;
-      }
-    break;
-
-  case kSqrtADUNoise :
-    for(i=0; i<npix; i++)
-      {
-      if ( (*pix <= max) && (*pix >= min) )  *pno = 1;
-      else *pno = (T) fsqrt(fabsf((float)(*pix)));    
-      pix++;   pno++;
-      }
-    break;
-
-  case kPhotonNoise :
-  case kSigFondNoise :
-    if ( dynccd->TypNoise == kSigFondNoise)
-      { fond = dynccd->RefFond;
-      ronsq = dynccd->RefSFond * dynccd->RefSFond; }
-    else
-      { fond = 0;
-      ronsq = dynccd->RONoise/dynccd->Gain;  ronsq *= ronsq; }
-
-// Calcul de minois / offnois pour obtenir un bruit correct malgre 
-// les conversions (float) -> (entier)
-
-    switch(pim->PixelType())
-      {
-      case kuint_2:
-      case kint_2:
-      case kint_4:
-        minois = 1.001;
-        offnois = 0.5;
-        break;
-      case kr_4:
-      case kr_8:
-        minois = 1.e-9;
-        offnois = 0.;
-        break;
-      default:
-        minois = 1.e-9;
-        offnois = 0.;
-        break;
-      }
-
-    for(i=0; i<npix; i++)
-      {
-      if ( (*pix <= max) && (*pix >= min) ) 
-        {
-        h = (*pix>fond) ? (float)(*pix)-fond : 0.;
-        s = ronsq+h/dynccd->Gain;
-        s = fsqrt(s)+offnois;
-        *pno = (s > minois) ? (T)s : (T)minois;
-        } 
-      else *pno = 0;
-      pix++;   pno++;
-      }
-    break;
-  }
+r_8 h,s,ronsq;
+r_8 fond, min,max;
+int_4 k, npix;
+r_8 minois, offnois;
+
+npix = pim.XSize()*pim.YSize();
+Image<T> nois(pim.XSize(), pim.YSize());
+nois.SetOrg(pim.XOrg(), pim.YOrg());
+
+min = dynccd.MinADU;   max = dynccd.MaxADU;
+for(k=0; k<npix; k++)      {
+  if ( (pim[k] <= max) && (pim[k] >= min) )  nois[k] = (T)1;
+  else nois[k] = 0;
+}
+
 
 return(nois);
@@ -258,89 +192,12 @@
 void ImgAddNoise(Image<T>& img, DynCCD const& dyn)
 {
-	T* p = img.ImagePtr();
-	int nPix = img.XSize() * img.YSize();
+  int_4 nPix = img.XSize() * img.YSize();
 	
-	for (int i=0; i<nPix; i++, p++)
-		*p += (T) (dyn.Noise(*p)*NorRand());
-}
-
-
-
-/* Nouvelle-Fonction */
-RzImage * NoiseImage(RzImage const * pim, DynCCD const * dynccd)
-
-/* Creation et Calcul d'une image de bruit a partir de l'image */
-/* pim et de dynccd. Voir la methode DynCCD::Noise() pour la   */
-/* description du calcul                                       */
-{
-RzImage * nois = NULL;
-
-switch (pim->PixelType()) 
-  {
-  case kuint_2: 
-    {
-    ImageU2 pix((RzImage&)(*pim));
-    nois = NoiseImage(&pix, dynccd);
-    break;
-    }
-  case kint_2:
-    {
-    ImageI2 pix((RzImage&)(*pim));
-    nois = NoiseImage(&pix, dynccd);
-    break;
-    }
-  case kint_4:
-    {
-    ImageI4 pix((RzImage&)(*pim));
-    nois = NoiseImage(&pix, dynccd);
-    break;
-    }
-  case kr_4:
-    {
-    ImageR4 pix((RzImage&)(*pim));
-    nois = NoiseImage(&pix, dynccd);
-    break;
-    }  
-  case kuint_4:
-  case kr_8:
-    cerr << "NoiseImage(RzImage, ...) Unsupported image type (kuint_4/kr_8) " 
-         << int(pim->PixelType()) << "\n" ; 
-    break;
-  default:
-    cerr << "NoiseImage(RzImage, ...) Unknown image type !! " << int(pim->PixelType()) << "\n" ;
-    break;
-  }   
-
-return(nois);
-}
-
-
-// ******** INSTANCES
-
-#if defined(__xlC) || defined(__aCC__)
-void instancetempdynccd(int n)
-{
-/* Cette fonction sert uniquement a forcer le compilo a instancier les
-  classes/fonctions template   */
-
-ImageU2  iu2(n,n), *piu2;
-ImageI2  ii2(n,n), *pii2;
-ImageI4  ii4(n,n), *pii4;
-ImageR4  ir4(n,n), *pir4;
-DynCCD dyn(1,0.,65000., 4., 20.);
-
-piu2 = NoiseImage(&iu2, &dyn);
-pii2 = NoiseImage(&ii2, &dyn);
-pii4 = NoiseImage(&ii4, &dyn);
-pir4 = NoiseImage(&ir4, &dyn);
-
-ImgAddNoise(*piu2, dyn);
-ImgAddNoise(*pii2, dyn);
-ImgAddNoise(*pii4, dyn);
-ImgAddNoise(*pir4, dyn);
-
-return;
-}
-#endif
+  for (int_4 i=0; i<nPix; i++)
+    img[i] += (T) (dyn.Noise(img[i])*NorRand());
+}
+
+
+
 
 
@@ -348,10 +205,8 @@
 
 #pragma define_template NoiseImage<uint_2>
-#pragma define_template NoiseImage<int_2>
 #pragma define_template NoiseImage<int_4>
 #pragma define_template NoiseImage<r_4>
 
 #pragma define_template ImgAddNoise<uint_2>
-#pragma define_template ImgAddNoise<int_2>
 #pragma define_template ImgAddNoise<int_4>
 #pragma define_template ImgAddNoise<r_4>
@@ -360,12 +215,10 @@
 
 
-#if ( defined(ANSI_TEMPLATES) && !defined(__aCC__) )
+#if defined(ANSI_TEMPLATES) 
 template Image<uint_2> * NoiseImage<uint_2>(Image<uint_2> const * , DynCCD const *);
-template Image< int_2> * NoiseImage< int_2>(Image< int_2> const * , DynCCD const *);
 template Image< int_4> * NoiseImage< int_4>(Image< int_4> const * , DynCCD const *);
 template Image<   r_4> * NoiseImage<   r_4>(Image<   r_4> const * , DynCCD const *);
 
 template void ImgAddNoise<uint_2>(Image<uint_2>&, DynCCD const&);
-template void ImgAddNoise< int_2>(Image< int_2>&, DynCCD const&);
 template void ImgAddNoise< int_4>(Image< int_4>&, DynCCD const&);
 template void ImgAddNoise<   r_4>(Image<   r_4>&, DynCCD const&);
@@ -375,10 +228,8 @@
 #if defined(__GNU_TEMPLATES__)
 template Image<uint_2> * NoiseImage(Image<uint_2> const *, DynCCD const *);
-template Image< int_2> * NoiseImage(Image< int_2> const *, DynCCD const *);
 template Image< int_4> * NoiseImage(Image< int_4> const *, DynCCD const *);
 template Image<   r_4> * NoiseImage(Image<   r_4> const *, DynCCD const *);
 
 template void ImgAddNoise(Image<uint_2>&, DynCCD const&);
-template void ImgAddNoise(Image< int_2>&, DynCCD const&);
 template void ImgAddNoise(Image< int_4>&, DynCCD const&);
 template void ImgAddNoise(Image<   r_4>&, DynCCD const&);
Index: trunk/SophyaLib/NTools/dynccd.h
===================================================================
--- trunk/SophyaLib/NTools/dynccd.h	(revision 1103)
+++ trunk/SophyaLib/NTools/dynccd.h	(revision 1104)
@@ -6,4 +6,5 @@
 #include "machdefs.h"
 #include "pexceptions.h"
+#include "cimage.h"
 #include "ppersist.h"
 
@@ -17,31 +18,25 @@
 
   int_4 TypNoise;        // Type de calcul du bruit 
-  float MinADU,MaxADU;   // Valeur min et max des pixels 
-  float Gain;            // Gain en electron/ADU 
-  float RONoise;         // Bruit de lecture en electron  
-  float RefFond;         // Fond de ciel de ref (TypNoise=2) 
-  float RefSFond;        // Sigma du fond  (TypNoise=2) */
+  r_8 MinADU,MaxADU;   // Valeur min et max des pixels 
+  r_8 Gain;            // Gain en electron/ADU 
+  r_8 RONoise;         // Bruit de lecture en electron  
+  r_8 RefFond;         // Fond de ciel de ref (TypNoise=2) 
+  r_8 RefSFond;        // Sigma du fond  (TypNoise=2) */
 
 /*    ===>  Les methodes   */
-  DynCCD(int typ=0, float min=-9.e19, float max=9.e19,
-         float g=1., float ron=0., float rf=0., float rfs=0.);
+  DynCCD(int_4 typ=0, r_8 min=-9.e19, r_8 max=9.e19,
+         r_8 g=1., r_8 ron=0., r_8 rf=0., r_8 rfs=0.);
 
-  void Set(int typ=0, float min=-9.e19, float max=9.e19,
-         float g=1., float ron=0., float rf=0., float rfs=0.);
+  void Set(int_4 typ=0, r_8 min=-9.e19, r_8 max=9.e19,
+         r_8 g=1., r_8 ron=0., r_8 rf=0., r_8 rfs=0.);
   void Print();
-  float Noise(float pixel) const;
+  r_8 Noise(r_8 pixel) const;
 };
 
 } // Fin du namespace
 
-// Quelques fonctions pour manipuler des images de bruit
-
-class RzImage;
-RzImage * NoiseImage(RzImage const *pim, DynCCD const * dynccd);
-
-template <class T> class Image;
 
 template <class T>
-Image<T> * NoiseImage(Image<T> const * pim, DynCCD const * dynccd);
+Image<T> NoiseImage(Image<T> const & pim, DynCCD const & dynccd);
 
 template <class T>
@@ -53,5 +48,5 @@
 {
   c.PutI4(data.TypNoise);
-  c.PutR4s(&data.MinADU, 6);
+  c.PutR8s(&data.MinADU, 6);
   return c;
 }
@@ -61,9 +56,9 @@
 {
   c.GetI4(data.TypNoise);
-  c.GetR4s(&data.MinADU, 6);
+  c.GetR8s(&data.MinADU, 6);
   return c;
 }
 
-//STRUCTPERSISTIO(DynCCD, TypNoise, sizeof(int_4)+6*sizeof(float))
+
 
 
Index: trunk/SophyaLib/NTools/exclude
===================================================================
--- trunk/SophyaLib/NTools/exclude	(revision 1103)
+++ trunk/SophyaLib/NTools/exclude	(revision 1104)
@@ -1,1 +1,1 @@
-
+imageop.cc
Index: trunk/SophyaLib/NTools/ntoolsinit.cc
===================================================================
--- trunk/SophyaLib/NTools/ntoolsinit.cc	(revision 1103)
+++ trunk/SophyaLib/NTools/ntoolsinit.cc	(revision 1104)
@@ -41,10 +41,7 @@
   DObjRegister(ObjFileIO<GeneralFitData>, GeneralFitData);
 
-  PPRegister(RzImage);
-  PPRegister(ImageU2);
-  PPRegister(ImageI2);
-  PPRegister(ImageI4);
-  PPRegister(ImageR4);
-
+  DObjRegister(FIO_TArray<uint_2>, Image<uint_2>);
+  DObjRegister(FIO_TArray<int_4>, Image<int_4>);
+  DObjRegister(FIO_TArray<r_4>, Image<r_4>);
 
 
